SystemOrganization addCategory: #'TP1-LSD-Inc'!
SystemOrganization addCategory: #'TP1-LSD-Inc-Testing'!

Trait named: #TConsumoEntradaPorPunto
	uses: {}
	category: 'TP1-LSD-Inc'!

!TConsumoEntradaPorPunto methodsFor: 'as yet unclassified' stamp: 'MarChU 4/14/2013 03:59'!
consumo: unaPantalla
	^ self definicion * self wattsPorPunto! !

!TConsumoEntradaPorPunto methodsFor: 'as yet unclassified' stamp: 'MarChU 4/14/2013 03:59'!
definicion
	self requiredMethods! !

!TConsumoEntradaPorPunto methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 21:36'!
wattsPorPunto
	self requiredMethods! !

Trait named: #TConsumoEntradaPorcentaje
	uses: {}
	category: 'TP1-LSD-Inc'!

!TConsumoEntradaPorcentaje methodsFor: 'as yet unclassified' stamp: 'MarChU 4/12/2013 04:40'!
consumo: unaPantalla
	^ unaPantalla consumo * self porcentaje! !

!TConsumoEntradaPorcentaje methodsFor: 'as yet unclassified' stamp: 'MarChU 4/12/2013 00:29'!
porcentaje
	self requiredMethods! !

Trait named: #TConsumoTecnologiaDeImagen
	uses: {}
	category: 'TP1-LSD-Inc'!

!TConsumoTecnologiaDeImagen methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 17:34'!
consumo
	^ self wattsPorHora * self tamanio! !

!TConsumoTecnologiaDeImagen methodsFor: 'as yet unclassified' stamp: 'MarChU 4/12/2013 04:24'!
tamanio
	self requiredMethods! !

!TConsumoTecnologiaDeImagen methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:43'!
wattsPorHora
	self requiredMethods! !

Trait named: #TEntrada480
	uses: {}
	category: 'TP1-LSD-Inc'!

!TEntrada480 methodsFor: 'as yet unclassified' stamp: 'MarChU 4/15/2013 00:02'!
puedeConectar: unCable
	^ unCable definicion = 480! !

Trait named: #TImagenAnalogica
	uses: {}
	category: 'TP1-LSD-Inc'!

!TImagenAnalogica commentStamp: '<historical>' prior: 0!
A TImagenAnalogica is xxxxxxxxx.
!

!TImagenAnalogica methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:53'!
definicionMaxima
	^ 480! !

Trait named: #TImagenDigital
	uses: {}
	category: 'TP1-LSD-Inc'!

!TImagenDigital commentStamp: '<historical>' prior: 0!
A TImagenDigital is un trait que se encarga de obtener la definicion de una tecnologia digital.
!

!TImagenDigital methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:51'!
definicionMaxima
	^ self ppp * ( ( self tamanio squared / 2 ) raisedTo: 0.5 )! !

!TImagenDigital methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:46'!
ppp
	self requiredMethods! !

!TImagenDigital methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 17:31'!
tamanio
	self requiredMethods! !

TestCase subclass: #ConsumoPantallaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc-Testing'!

!ConsumoPantallaTest methodsFor: 'as yet unclassified' stamp: 'MarChU 4/15/2013 00:46'!
testLCDConVGA	
	| builder pantalla |
	builder := MonitorBuilder new.
	builder setTecnologiaLCD: 17 PPP: 100.
	pantalla := builder build.
	pantalla cambiarEntrada: VGA new.
	pantalla conectar: ( Cable newCable: 720 ).
	self assert: pantalla consumo = 68.72.! !

TestCase subclass: #DefinicionMaximaPantallaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc-Testing'!

!DefinicionMaximaPantallaTest commentStamp: '<historical>' prior: 0!
A DefinicionMaximaPantallaTest is xxxxxxxxx.

Instance Variables
!

!DefinicionMaximaPantallaTest methodsFor: 'as yet unclassified' stamp: 'MarChU 4/15/2013 00:48'!
testLCD
	| builder pantalla |
	builder := MonitorBuilder new.
	builder setTecnologiaLCD: 17 PPP: 100.
	pantalla := builder build.
	self assert: pantalla definicionMaxima rounded = 1202.! !

TestCase subclass: #JugarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc-Testing'!

!JugarTest methodsFor: 'as yet unclassified' stamp: 'MarChU 4/15/2013 01:02'!
testLCD
	| builder pantalla |
	builder := MonitorBuilder new.
	builder setTecnologiaLCD: 17 PPP: 100.
	pantalla := builder build.
	pantalla cambiarEntrada: VGA new.
	pantalla conectar: ( Cable newCable: 720 ).
	self assert: pantalla jugar.! !

Object subclass: #Cable
	instanceVariableNames: 'definicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

!Cable class methodsFor: 'as yet unclassified' stamp: 'MarChU 4/15/2013 00:27'!
newCable: unaDefinicion
		| instance |
		instance := Cable new.
		instance definicion: unaDefinicion.
		^ instance! !

!Cable class methodsFor: 'as yet unclassified' stamp: 'MarChU 4/15/2013 00:29'!
newCable: unaDefinicion conRefresco: unRefresco
		| instance |
		instance := CableHDMI new.
		instance definicion: unaDefinicion.
		instance refresco: unRefresco.
		^ instance! !

!Cable methodsFor: 'accessing' stamp: 'MarChU 4/14/2013 02:22'!
definicion
	^ definicion! !

!Cable methodsFor: 'accessing' stamp: 'MarChU 4/14/2013 02:22'!
definicion: anObject
	definicion := anObject! !

Cable subclass: #CableHDMI
	instanceVariableNames: 'refresco'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

!CableHDMI methodsFor: 'accessing' stamp: 'MarChU 4/14/2013 02:22'!
refresco
	^ refresco! !

!CableHDMI methodsFor: 'accessing' stamp: 'MarChU 4/14/2013 02:22'!
refresco: anObject
	refresco := anObject! !

Object subclass: #Entrada
	instanceVariableNames: 'cable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

Entrada subclass: #AudioVideo
	uses: TConsumoEntradaPorcentaje + TEntrada480
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

AudioVideo class
	uses: TConsumoEntradaPorcentaje classTrait + TEntrada480 classTrait
	instanceVariableNames: ''!

!AudioVideo methodsFor: 'as yet unclassified' stamp: 'MarChU 4/12/2013 05:05'!
porcentaje
	^ 0.1! !

!AudioVideo methodsFor: 'as yet unclassified' stamp: 'MarChU 4/14/2013 01:38'!
refrescoMaximo
	^ 50! !

!Entrada methodsFor: 'accessing' stamp: 'MarChU 4/15/2013 00:41'!
cable
	^ cable! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'MarChU 4/14/2013 22:48'!
conectar: unCable
	cable := unCable! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'MarChU 4/14/2013 03:07'!
consumo: unaPantalla
	self subclassResponsability! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'MarChU 4/14/2013 23:57'!
definicion
	^ self cable definicion! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'MarChU 4/14/2013 23:55'!
puedeConectar: unCable
	^ true! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'MarChU 4/14/2013 03:07'!
refrescoMaximo
	self subclassResponsability! !

Entrada subclass: #HDMI
	uses: TConsumoEntradaPorcentaje
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

HDMI class
	uses: TConsumoEntradaPorcentaje classTrait
	instanceVariableNames: ''!

!HDMI methodsFor: 'as yet unclassified' stamp: 'MarChU 4/12/2013 05:05'!
porcentaje
	^ 0.2! !

!HDMI methodsFor: 'as yet unclassified' stamp: 'MarChU 4/14/2013 03:56'!
refrescoMaximo
	^ self cable refresco! !

Entrada subclass: #RF
	uses: TEntrada480
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

RF class
	uses: TEntrada480 classTrait
	instanceVariableNames: ''!

!RF methodsFor: 'as yet unclassified' stamp: 'MarChU 4/12/2013 00:38'!
consumo: pantalla
		^ 0! !

!RF methodsFor: 'as yet unclassified' stamp: 'MarChU 4/14/2013 01:42'!
refrescoMaximo
	^ 50! !

Entrada subclass: #VGA
	uses: TConsumoEntradaPorPunto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

VGA class
	uses: TConsumoEntradaPorPunto classTrait
	instanceVariableNames: ''!

!VGA methodsFor: 'as yet unclassified' stamp: 'MarChU 4/14/2013 23:59'!
definicion
	^ super definicion! !

!VGA methodsFor: 'as yet unclassified' stamp: 'MarChU 4/15/2013 00:57'!
refrescoMaximo
	^ 120! !

!VGA methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 21:37'!
wattsPorPunto
	^ 0.001! !

Object subclass: #Pantalla
	instanceVariableNames: 'refresco tecnologia entrada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/15/2013 00:24'!
cambiarEntrada: anObject
	entrada := anObject! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/15/2013 00:40'!
conectar: unCable
	( self puedeConectar: unCable ) ifTrue: [ self entrada conectar: unCable ] ifFalse: [ Exception signal: 'No se pudo conectar el cable.' ]
! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/15/2013 00:13'!
consumo
	^ self tecnologia consumo + ( self entrada consumo: self )! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/15/2013 00:12'!
definicionMaxima
	^ self tecnologia definicionMaxima! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/15/2013 00:08'!
entrada
	^ entrada! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/15/2013 00:19'!
jugar
	^ self refrescoReal > 100! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/15/2013 00:40'!
puedeConectar: unCable
	^ ( self definicionMaxima >= unCable definicion ) and: [ self entrada puedeConectar: unCable ]! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 06:29'!
refresco
	^ refresco! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/12/2013 07:27'!
refresco: anObject
	refresco := anObject! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/15/2013 00:57'!
refrescoReal
	^ ( self refresco ) min: ( self entrada refrescoMaximo )! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 06:06'!
tecnologia
	^ tecnologia! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/12/2013 07:26'!
tecnologia: anObject
	tecnologia := anObject! !

Object subclass: #PantallaBuilder
	instanceVariableNames: 'tecnologia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

PantallaBuilder subclass: #MonitorBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

!MonitorBuilder methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 01:11'!
refrescoPantalla
	^ 120.! !

!PantallaBuilder methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 01:31'!
build
	| instance |
	instance := Pantalla new.
	instance tecnologia: self tecnologia.
	instance refresco: self refrescoPantalla.
	^ instance.! !

!PantallaBuilder methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 01:09'!
refrescoPantalla
	self subclassResponsability! !

!PantallaBuilder methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 01:29'!
setTecnologiaCRT: unTamanio
	| instance |
	instance := CRT new.
	instance tamanio: unTamanio.
	self tecnologia: instance.
	! !

!PantallaBuilder methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 01:29'!
setTecnologiaLCD: unTamanio PPP: unPpp
	| instance |
	instance := LCD new.
	instance tamanio: unTamanio.
	instance ppp: unPpp.
	self tecnologia: instance.! !

!PantallaBuilder methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 01:29'!
setTecnologiaLED: unTamanio PPP: unPpp
	| instance |
	instance := LED new.
	instance tamanio: unTamanio.
	instance ppp: unPpp.
	self tecnologia: instance.! !

!PantallaBuilder methodsFor: 'accessing' stamp: 'MarChU 4/13/2013 01:29'!
tecnologia
	^ tecnologia! !

!PantallaBuilder methodsFor: 'accessing' stamp: 'MarChU 4/13/2013 01:29'!
tecnologia: anObject
	tecnologia := anObject! !

PantallaBuilder subclass: #SmartTVBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

!SmartTVBuilder methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 01:11'!
refrescoPantalla
	^ 135.! !

!SmartTVBuilder methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 17:51'!
setTecnologiaCRT: unTamanio
	Exception signal: 'Solo permite tecnologia LED'.! !

!SmartTVBuilder methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 17:51'!
setTecnologiaLCD: unTamanio PPP: unPpp
	Exception signal: 'Solo permite tecnologia LED'.! !

PantallaBuilder subclass: #TVBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

!TVBuilder methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 01:11'!
refrescoPantalla
	^ 90.! !

Object subclass: #TecnologiaDeImagen
	instanceVariableNames: 'tamanio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

TecnologiaDeImagen subclass: #CRT
	uses: TImagenAnalogica + TConsumoTecnologiaDeImagen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

CRT class
	uses: TImagenAnalogica classTrait + TConsumoTecnologiaDeImagen classTrait
	instanceVariableNames: ''!

!CRT methodsFor: 'as yet unclassified' stamp: 'MarChU 4/12/2013 06:12'!
tamanio
	^ tamanio! !

!CRT methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:34'!
wattsPorHora
	^ 5! !

TecnologiaDeImagen subclass: #LCD
	uses: TImagenDigital + TConsumoTecnologiaDeImagen
	instanceVariableNames: 'ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

LCD class
	uses: TImagenDigital classTrait + TConsumoTecnologiaDeImagen classTrait
	instanceVariableNames: ''!

!LCD methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 03:38'!
ppp
	^ ppp! !

!LCD methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 03:38'!
ppp: anObject
	ppp := anObject! !

!LCD methodsFor: 'as yet unclassified' stamp: 'MarChU 4/12/2013 06:12'!
tamanio
	^ tamanio! !

!LCD methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:36'!
wattsPorHora
	^ 4! !

TecnologiaDeImagen subclass: #LED
	uses: TImagenDigital + TConsumoTecnologiaDeImagen
	instanceVariableNames: 'ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

!LED commentStamp: '<historical>' prior: 0!
A LED is una representacion de una pantalla con tecnologia LED.

Instance Variables
	ppp:		<Object>

ppp
	- xxxxx
!

LED class
	uses: TImagenDigital classTrait + TConsumoTecnologiaDeImagen classTrait
	instanceVariableNames: ''!

!LED methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 03:38'!
ppp
	^ ppp! !

!LED methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 03:38'!
ppp: anObject
	ppp := anObject! !

!LED methodsFor: 'as yet unclassified' stamp: 'MarChU 4/12/2013 06:12'!
tamanio
	^ tamanio! !

!LED methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:36'!
wattsPorHora
	^ 1! !

!TecnologiaDeImagen methodsFor: 'as yet unclassified' stamp: 'MarChU 4/12/2013 04:25'!
consumo
	self subclassResponsability! !

!TecnologiaDeImagen methodsFor: 'as yet unclassified' stamp: 'MarChU 4/13/2013 22:44'!
definicionMaxima
	self subclassResponsability! !

!TecnologiaDeImagen methodsFor: 'accessing' stamp: 'MarChU 4/12/2013 04:26'!
tamanio
	^ tamanio! !

!TecnologiaDeImagen methodsFor: 'accessing' stamp: 'MarChU 4/12/2013 07:25'!
tamanio: anObject
	tamanio := anObject! !

!TecnologiaDeImagen methodsFor: 'as yet unclassified' stamp: 'MarChU 4/12/2013 04:18'!
wattsPorHora
	self subclassResponsibility! !
